#include "duration.h"
#include <algo.h>

Duration::Duration()
 : m_max(0)
#ifdef OS2
 , m_start(0)
#else
 , m_start()
#endif
{
}

void Duration::start()
{
  getTime(&m_start);
}

DUR_TYPE Duration::stop()
{
  TIMEVAL_TYPE tv;
  getTime(&tv);
  DUR_TYPE ret;
#ifdef OS2
  ret = (unsigned long)(tv - m_start) * 1000;
#else
  ret = (tv.tv_sec - m_start.tv_sec) * 1000000
       + tv.tv_usec - m_start.tv_usec;
#endif
  m_max = max(m_max, ret);
  return ret;
}

bool Duration::getTime(TIMEVAL_TYPE *tv)
{
#ifdef OS2
  ULONG rc = DosQuerySysInfo(QSV_MS_COUNT, QSV_MS_COUNT, tv, sizeof(count));
  if(rc)
    return true;
#else
  if (gettimeofday(tv, static_cast<struct timezone *>(NULL)) == -1)
    return true;
#endif
  return false;
}
